
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>select/poll/epoll on serial port / 憋错料</title>

    <meta name="description" content="select/poll/epoll on serial port In this article, I will use three asynchronous conferencing--select, poll and epoll on serial port to transmit data between PC and Raspberry pi. Outline Character device file of serial port Naive serial communication Asynchronous conferencing Select">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">select/poll/epoll on serial port</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>In this article, I will use three asynchronous conferencing--select, poll and epoll on serial port to transmit data between PC and Raspberry pi.</p>
<hr />
<h2>Outline</h2>
<ol>
<li>Character device file of serial port</li>
<li>Naive serial communication</li>
<li>Asynchronous conferencing</li>
<li>Select</li>
<li>Poll</li>
<li>Epoll</li>
</ol>
<hr />
<h3>Character device of serial port</h3>
<p>My device is Raspberry pi with debian system and PC with ubuntu12.04 system.</p>
<p>And I have used a USB-TTL to link the these device.</p>
<p>The character device files on the two device is :</p>
<blockquote><p>/dev/ttyUSB0   #Ubuntu</p>
<p>/dev/ttyAMA0    #Debian Raspberry pi</p></blockquote>
<p>These two files are what we must use to achieve the lab.</p>
<p>But there is a little trap of /dev/ttyAMA0.</p>
<p>By default, Raspberry pi uses /dev/ttyAMA0 as a output of serial. Therefor we could use minicom or putty to control our device. However, we have to modify the default function of serial, since we will use our own method to use serial port.</p>
<p>So we should modify two files:</p>
<p>/boot/comdline.txt</p>
<blockquote><p>dwc_otg.lpm_enable=0 console=ttyAMA0,115200 rootfstype=ext4 elevator=deadline rootwait console=tty1 root=/dev/mmcblk0p2</p></blockquote>
<p>Delete <q>console=ttyAMA0,115200</q></p>
<p>/etc/inittab</p>
<blockquote><p>T0:23:respawn:/sbin/getty -L ttyAMA0 115200 vt100</p></blockquote>
<p>Comment the line above.</p>
<hr />
<br />Now, start to code:</p>
<h2>Naive version</h2>
<p>The naive serial port communication version</p>
<p>Open the device, set the baud rate, and set parity</p>
<pre><code>#include     &lt;stdio.h&gt;      /*标准输入输出定义*/
#include     &lt;string.h&gt;
#include     &lt;stdlib.h&gt;     /*标准函数库定义*/
#include     &lt;unistd.h&gt;     /*Unix标准函数定义*/
#include     &lt;sys/types.h&gt;  /**/
#include     &lt;sys/stat.h&gt;   /**/
#include     &lt;fcntl.h&gt;      /*文件控制定义*/
#include     &lt;termios.h&gt;    /*PPSIX终端控制定义*/
#include     &lt;errno.h&gt;      /*错误号定义*/
#define FALSE 0
#define TRUE 1

void set_speed(int fd) {
    struct  termios Opt;
    tcgetattr(fd, &amp;Opt);
    cfsetispeed(&amp;Opt,B115200);
    cfsetospeed(&amp;Opt,B115200);
    tcsetattr(fd,TCSANOW,&amp;Opt);
    return;
}

void set_Parity(int fd) {
    struct termios options;
    tcgetattr(fd, &amp;options);
    options.c_lflag  &amp;= ~(ICANON | ECHO | ECHOE | ISIG);  /*Input*/
    options.c_oflag  &amp;= ~OPOST;   /*Output*/
    tcsetattr(fd,TCSANOW,&amp;options);
    return;
}

int OpenSerial(char *Dev) {
    int fd = open( Dev, O_RDWR );         //| O_NOCTTY | O_NDELAY
    if (-1 == fd) { /*设置数据位数*/
        perror(&quot;Can&#039;t Open Serial Port&quot;);
        return -1;
    }
    else {
        set_speed(fd);
        set_Parity(fd);
        return fd;
    }

}

int main(){
    int fd;
    ssize_t length;
    char buff[512];
    char *dev =&quot;/dev/ttyAMA0&quot;;
    fd = OpenSerial(dev);
    for(;;){
        length = read(fd,buff,sizeof(buff));
        if(length &gt; 0) {
            buff[length] = 0;
            printf(&quot;plain:%s\n&quot;,buff);
        }
    }
    close(fd);
    exit(0);
}

</code></pre>
<hr />
<h2>Select version</h2>
<pre><code>#include &lt;sys/time.h&gt;
#include &lt;sys/types.h&gt;
#include &quot;serial/serial.h&quot;

int main() {
    int fd;
    fd_set rfds;
    struct timeval tv;
    char buff[512];
    ssize_t length;
    fd = OpenSerial(&quot;/dev/ttyAMA0&quot;);

    for(;;) {
        FD_ZERO(&amp;rfds);
        FD_SET(fd, &amp;rfds);

        //timeout = 5s
        tv.tv_sec = 5;
        tv.tv_usec = 0;
        //Wait for 5 seconds, then go
        int n;
        n = select(fd + 1, &amp;rfds, NULL, NULL, &amp;tv);
        //choose the target from set
        if(n &gt; 0) {
            if (FD_ISSET(fd, &amp;rfds)) {
                length = read(fd, &amp;buff, sizeof(buff));
                buff[length] = 0;
                printf(&quot;select:%s\n&quot;, buff);
            }
        } else {
            printf(&quot;No data within 5 seconds.\n&quot;);
        }
    }
    return 0;
}

</code></pre>
<h2>Poll version</h2>
<pre><code>#include &lt;sys/poll.h&gt;
#include &quot;serial/serial.h&quot;
int main(void) {
    struct pollfd fds[1];
    ssize_t length;
    char buff[512];
    fds[0].fd = OpenSerial(&quot;/dev/ttyAMA0&quot;);
    fds[0].events = POLLIN ;
    for(;;) {
        int n;
        n = poll( fds, 1, 5000);
        //got data, and look up which fd has data, but we just have 1
        if(n &gt; 0) {
        //if( fds[0].revents &amp; POLLIN ) {
            length = read(fds[0].fd, buff, sizeof(buff) );
            buff[length] = 0;
            printf(&quot;poll:%s\n&quot;,buff);

        } else {
            printf(&quot;No data within 5 seconds.\n&quot;);
        }
    }
} 

</code></pre>
<h2>Epoll version</h2>
<pre><code>#include &lt;sys/epoll.h&gt;
#include &quot;serial/serial.h&quot;

#define MAXEVENTS 64

int main(void){
    int fd;
    int efd;
    struct epoll_event event;
    struct epoll_event *events;
    int length;
    char buff[512];
    fd = OpenSerial(&quot;/dev/ttyAMA0&quot;);
    efd = epoll_create1 (0);//initial is 0

    event.data.fd = fd;
    event.events = EPOLLIN | EPOLLET;

    epoll_ctl (efd, EPOLL_CTL_ADD, fd, &amp;event);
    /* Buffer where events are returned */
    events = calloc (MAXEVENTS, sizeof event);

    /* The event loop */
    for(;;) {
        int n;
        n = epoll_wait (efd, events, MAXEVENTS, 5000);
        if(n &gt; 0) {
            length = read(events[0].data.fd, buff, sizeof(buff));

            if(length &gt; 0) {
                buff[length] = 0;
                printf(&quot;epoll:%s\n&quot;, buff);
            }
        } else {
            printf(&quot;No data whthin 5 seconds.\n&quot;);
        }
    }
    free (events);
    close (fd);
    return 0;
}
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 06:53:43 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>select/poll/epoll on serial port的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyKPg0.html" rel="bookmark">Linux统系统开发12 Socket API编程3 TCP状态转换 多路IO高并发select  poll  epoll udp组播 线程池</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[本文谢绝转载原文来自http://990487026.blog.51cto.com] Linux统系统开发12 Socket API编程3 TCP状态转换 多路IO高并发select  poll  epoll udp组播 线程池 TCP 11种状态理解: 1,客户端正常发起关闭请求 2,客户端与服务端同时发起关闭请求 3,FIN_WAIT1直接转变TIME_WAIT 4,客户端接收来自服务器的关闭连接请求 多路IO转接服务器: select模型 poll模型 epoll模型 udp组播模型 线			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0doNynM.html" rel="bookmark">&num; 进程&sol;线程&sol;协程 &num; IO&colon;同步&sol;异步&sol;阻塞&sol;非阻塞 &num;  greenlet gevent &num; 事件驱动与异步IO &num; Select&bsol;Poll&bsol;Epoll异步IO 以及selectors模块 &num; Python队列&sol;RabbitMQ队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 # 进程/线程/协程 2 # IO:同步/异步/阻塞/非阻塞 3 # greenlet gevent 4 # 事件驱动与异步IO 5 # Select\Poll\Epoll异步IO 以及selectors模块 6 # Python队列/RabbitMQ队列 7 8 ############################################################################################## 9 1.什么是进程?进程和程序之间有什么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NjlmZ4.html" rel="bookmark">多进程、协程、事件驱动及select poll epoll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 -多线程使用场景 -多进程 --简单的一个多进程例子 --进程间数据的交互实现方法 ---通过Queues和Pipe可以实现进程间数据的传递,但是不能实现数据的共享 ---Queues ---Pipe ---通过Manager可以不同进程间实现数据的共享 --进程同步,即进程锁 --进程池 -协程 --先用yield实现简单的协程 --Greenlet --Gevent --用协程gevent写一个简单并发爬网页 -事件驱动 --IO多路复用 ---用户空间和内核空间 ---文件描述符fd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n7rGN3.html" rel="bookmark">select&comma;poll&comma;epoll用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/sunboy_2050/article/details/6126712 select用法 #include &lt;sys/time.h&gt;       #include &lt;sys/types.h&gt;       #include &lt;unistd.h&gt; #include &lt;sys/select.h&gt; int select(int n, fd_set *readfds, fd_set *writefds, fd_set *exc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38Dr5K3.html" rel="bookmark">几种典型的服务器网络编程模型归纳&lpar;select poll epoll&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.同步阻塞迭代模型 同步阻塞迭代模型是最简单的一种IO模型. 其核心代码如下: bind(srvfd); listen(srvfd); for(;;) { clifd = accept(srvfd,...); //开始接受客户端来的连接 read(clifd,buf,...); //从客户端读取数据 dosomthingonbuf(buf); write(clifd,buf)//发送数据到客户端 } 上面的程序存在如下一些弊端: 1)如果没有客户端的连接请求,进程会阻塞在accept系统调用处			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5vLv0.html" rel="bookmark">Linux下select&amp;amp&semi;poll&amp;amp&semi;epoll的实现原理（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近简单看了一把Linux linux-3.10.25 kernel中select/poll/epoll这个几个IO事件检测API的实现.此处做一些记录.其基本的原理是相同的,流程如下 先依次调用fd对应的struct file.f_op-&gt;poll()方法(如果有提供实现的话),尝试检查每个提供待检测IO的fd是否已经有IO事件就绪 如果已经有IO事件就绪,则直接所收集到的IO事件返回,本次调用结束 如果暂时没有IO事件就绪,则根据所给定的超时参数,选择性地进入等待 如果超时参数指示不等待,则			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGG2OZM.html" rel="bookmark">I&sol;O多路复用之select&comma;poll&comma;epoll简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.select 1.起源 select最早于1983年出现在4.2BSD中(BSD是早期的UNIX版本的分支). 它通过一个select()系统调用来监视多个文件描述符的数组,当select()返回后,该数组中就绪的文件描述符便会被内核修改标志位,使得进程可以获得这些文件描述符从而进行后续的读写操作. 2.select的优点 目前几乎在所有的平台上支持,具有良好的跨平台支持. 3.select的缺点 单个进程能够监视的文件描述符的数量存在最大限制.默认情况下,在Linux上单个进程能够打开的最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPdo6mM.html" rel="bookmark">转一贴，今天实在写累了，也看累了--【Python异步非阻塞IO多路复用Select&sol;Poll&sol;Epoll使用】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面这篇,原理理解了, 再结合 这一周来的心得体会,整个框架就差不多了... http://www.haiyun.me/archives/1056.html 有许多封装好的异步非阻塞IO多路复用框架,底层在linux基于最新的epoll实现,为了更好的使用,了解其底层原理还是有必要的.下面记录下分别基于Select/Poll/Epoll的echo server实现.Python Select Server,可监控事件数量有限制: 1 2 3 4 5 6 7 8 9 10 11 12 13 14			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38LBKy3.html" rel="bookmark">Linux内核中网络数据包的接收-第二部分 select&sol;poll&sol;epoll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				和前面文章的第一部分一样,这些文字是为了帮别人或者自己理清思路的,而不是所谓的源码分析,想分析源码的,还是直接debug源码最好,看任何文档以及书都是下策.因此这类帮人理清思路的文章尽可能的记成流水的方式,尽可能的简单明了. Linux 2.6+内核的wakeup callback机制 Linux 内核通过睡眠队列来组织所有等待某个事件的task,而wakeup机制则可以异步唤醒整个睡眠队列上的task,每一个睡眠队列上的节点都拥有一个 callback,wakeup逻辑在唤醒睡眠队列时,会遍历			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMGlEy0.html" rel="bookmark" class="title">JAVA开发程序，使用编辑器编写程序代码</a>
					<div>
						打开Eclipse 出现界面 工作空间的路径可以选择一个大空间的磁盘存放,点击确定: 创建:程序左上角-文件-新建-JAVA项目 输入项目名(项目名不能为中文),点击完成: 在   包资源管理器中点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RlDP4.html" rel="bookmark" class="title">jQuery的效果函数</a>
					<div>
						1.基本效果 匹配元素从左上角开始变浓变大或缩小到左上角变淡变小 ①隐藏元素 除了可以设置匹配元素的display:none外,可以用以下函数 hide(speed,[callback])  返回值: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaAdk4.html" rel="bookmark" class="title">C&num; JArray与JObject 的使用 json &lbrack;&lbrace;&rcub;&rsqb;</a>
					<div>
						C# JArray与JObject 的使用 STEP1.using Newtonsoft.Json.Linq; STEP2 如何获取json里的某个属性(节点)值,对其删改,新增 //2.1 数组用J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mza2dy4.html" rel="bookmark" class="title">css3 选择器 权重问题 （第二部分）</a>
					<div>
						这篇博文有关css的权重问题,我个人认为这是css知识中很重要的一个知识点.因为在开发的过程能中我们会经常遇到这种问题,特别是如果你使用框架的时候,有些框架的某些标签有一些默认的样式.所以我们可以通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ZwlgM.html" rel="bookmark" class="title">Sublime Text3安装配置</a>
					<div>
						Sublime Text3的所有package都可在如下网站检索 https://packagecontrol.io/browse 以下是我的插件列表 CoolFormat 一款C\C++\C#\CS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEnEb3.html" rel="bookmark" class="title">完美解决oracle11gR2安装grid检查ASM报错PRVG-10122</a>
					<div>
						报错PRVG-10122 rac1,rac2都报错 先讲主要原因:kmod-oracleasm包的版本比较老,要安装适配自己内核版本的 首先我在rac1上卸载掉之前下载的kmod-oracleasm  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDoLvM.html" rel="bookmark" class="title">win10 localhost 解析为 ipv6地址 &colon;&colon;1 的解决办法</a>
					<div>
						localhost 访问时提示 not found 404,但是有127.0.0.1可以访问.最后找到原因,是因为 windows 把 localhost 解析为 ipv6 地址 ::1 而不是 12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K26QOM.html" rel="bookmark" class="title">浅谈信息安全</a>
					<div>
						对于很多IT公司来说,信息安全是老生常谈的问题了.那么如何做到信息安全呢?我们先来看下面两个故事. 施乐公司的帕洛奥图研究中心(常被叫做&quot;施乐PARC&quot;) 成立于1970年,是图形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ey6ep0.html" rel="bookmark" class="title">VS 2012 常用快捷</a>
					<div>
						1. 强迫智能感知:Ctrl+J: 2.强迫智能感知显示参数信息:Ctrl-Shift-空格: 3.格式化整个块:Ctrl+K+F 4. 检查括号匹配(在左右括号间切换): Ctrl +] 5. 选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZ5NYM.html" rel="bookmark" class="title">Linux 文件内容处理命令 --&amp;gt&semi; grep</a>
					<div>
						1.功能概述 输出指定文本中符合匹配模式的行,其中模式(pattern)由文本字符和正则表达式组合而成 2.基础格式 grep [options] PATTERN [FILE...] 3.常用参数 - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38blrnM.html" rel="bookmark" class="title">KVO运行时</a>
					<div>
						#import &quot;CZNews.h&quot; #import &lt;objc/runtime.h&gt;//**************一定要引入这个头文件************* @ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8XXm3.html" rel="bookmark" class="title">我理解的iOS中的RunTime机制（1）</a>
					<div>
						一.首先我们要先知道object-c是一门编译型.动态语言(这里强调下oc是静态类型语言),这在开发语言中是并多见的,一般的动态语言多为解释性语言.oc之所以能够做到即使编译型语言,又是动态语言.就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1NDP3.html" rel="bookmark" class="title">STM32 串行通信 USART 程序例举</a>
					<div>
						STM32 串行通信 USART 的笔记讲解连接http://blog.csdn.net/dragon12345666/article/details/24484185 1.串行通信 软件仿真STM3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjZqa4.html" rel="bookmark" class="title">多线程之：用户态和内核态的区别</a>
					<div>
						一:大话版用户态和内核态 (1)用户态和内核态的概念? ---&gt;内核态: CPU可以访问内存所有数据, 包括外围设备, 例如硬盘, 网卡. CPU也可以将自己从一个程序切换到另一个程序---&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAAn60.html" rel="bookmark" class="title">v9 推荐位 排序问题解决办法</a>
					<div>
						原网站:http://bbs.phpcms.cn/thread-879943-1-1.html 简介: 用phpcms做网站的时候,有些地方要用到推荐位列表,如幻灯片,特别推荐等.有时候因为文章的重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pg1DP3.html" rel="bookmark" class="title">poj 1611&lpar;详解&rpar;</a>
					<div>
						The Suspects Time Limit: 1000MS   Memory Limit: 20000K Total Submissions: 22217   Accepted: 10805 De ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLx12WM.html" rel="bookmark" class="title">iOS开发&mdash;&mdash;全局响应MotionEvent</a>
					<div>
						遇到这样一个需求:应用无论处于哪个view controller,摇动手机,都能够出发某一方法. 能够想到的思路就是用苹果封装好的&quot;MotionEvent&quot;,但是如果简单的把一下代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NQzjZ3.html" rel="bookmark" class="title">Java--笔记（5）</a>
					<div>
						41．面向对象的五大基本原则 (1)单一职责原则(SRP) (2)开放封闭原则(OCP) (3)里氏替换原则(LSP) (4)依赖倒置原则(DIP) (5)接口隔离原则(ISP) 单一职责原则(SRP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K12pO4.html" rel="bookmark" class="title">Java五大框架</a>
					<div>
						2017-6-13 Lifusen 此文章仅代表个人观点,如有问题提出请联系Q:5704296011.Hibernate (开放源代码的对象关系映射框架) Hibernate是一个开放源代码的对象关系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jln1Y0.html" rel="bookmark" class="title">R文件clean后丢失无法恢复，个人的解决方法。</a>
					<div>
						今天在导入以前做的工程的时候,发现有一些莫名其妙的错误,然后我就clean了一下.结果更多的错误出现了...5555,定睛一看,发现原来是R文件没了. 开始的时候,看到自己的xml的style有一个很 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
